#include <stdio.h>
#include <stdlib.h>


#define KEYSIZE 16
#define swap(a, b) ((a) ^= (b), (b) = (a) ^ (b), (a) ^= (b))


size_t PRGA(unsigned char *S, unsigned char *input, size_t inputLength, unsigned char *output) {
    int i = 0;
    int j = 0;
    size_t n = 0;
    for(size_t len = inputLength; n < len; n++) {
        i = (i + 1) % 256;
        j = (j + S[i]) % 256;

        swap(S[i], S[j]);
        int rnd = S[(S[i] + S[j]) % 256];

        output[n] = rnd ^ input[n];
    }
    return n;
}

int KSA(unsigned char *key, unsigned char *S) {

    int j = 0;

    for(int i = 0; i < 256; i++)
        S[i] = i;

    for(int i = 0; i < 256; i++) {
        j = (j + S[i] + key[i % KEYSIZE]) % 256;

        swap(S[i], S[j]);
    }

    return 0;
}

size_t RC4(unsigned char *key, unsigned char *input, size_t inputLength, unsigned char *output) {
    unsigned char *S = malloc(256);

    KSA(key, S);

    size_t decLen = PRGA(S, input, inputLength, output);
    free(S);

    return decLen;
}
